VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "mscomctl.ocx"
Begin VB.UserControl ColorListBox 
   ClientHeight    =   1980
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   2925
   ScaleHeight     =   1980
   ScaleWidth      =   2925
   Begin VB.ListBox nU 
      Height          =   255
      Left            =   4680
      TabIndex        =   2
      Top             =   480
      Visible         =   0   'False
      Width           =   1095
   End
   Begin VB.ListBox nS 
      Height          =   255
      Left            =   4680
      Sorted          =   -1  'True
      TabIndex        =   1
      Top             =   120
      Visible         =   0   'False
      Width           =   1095
   End
   Begin MSComctlLib.TreeView TV 
      Height          =   1575
      Index           =   0
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   2535
      _ExtentX        =   4471
      _ExtentY        =   2778
      _Version        =   393217
      LabelEdit       =   1
      FullRowSelect   =   -1  'True
      BorderStyle     =   1
      Appearance      =   1
   End
End
Attribute VB_Name = "ColorListBox"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' *************************
' * Geschrieben von       *
' *     Wolfgang Ehrhardt *
' *                       *
' *      woeh@gmx.de      *
' *************************

Public Event Click()
Public Event DblClick()

Public Event ItemCheck(Index As Integer)
Public Event ItemClick(Index As Integer)

Public Event KeyDown(KeyCode As Integer, Shift As Integer)
Public Event KeyPress(KeyAscii As Integer)
Public Event KeyUp(KeyCode As Integer, Shift As Integer)

Public Event MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
Public Event MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
Public Event MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)

Private Declare Function SearchLB Lib "USER32" Alias "SendMessageA" (ByVal Hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As String) As Long

Private Const LB_FINDSTRINGEXACT As Long = &H1A2

Public Enum Apperance
    ccFlat = 0
    cc3D = 1
End Enum

Public Enum BorderStyle
    None = 0
    FixedSingle = 1
End Enum

Public Enum Style
    Standard = 0
    Kontrollkstchen = 1
End Enum

Public Type lItem
    BackColor As Long
    Bold As Boolean
    Checked As Boolean
    ItemData As Long
    ForeColor As Long
    Text As String
End Type


Private Type nNodeNFO
    BackColor As Long
    Bold As Boolean
    Checked As Boolean
    ItemData As Long
    ForeColor As Long
    Text As String
End Type

Private LB As ListBox

Private xNode() As nNodeNFO
Private My As MyProgNFO

Private nNewIndex As Integer, nStyle As Style
Private isSorted As Boolean
Public Property Get Style() As Style
    Style = nStyle
End Property
Public Property Let Style(vData As Style)
    Dim P As Integer
    
    ReDim xNode(TV(0).Nodes.Count)
        
    For P = 1 To TV(0).Nodes.Count
        xNode(P).Checked = TV(0).Nodes(P).Checked
    Next P
    
    TV(0).Checkboxes = CBool(vData * -1)
    
    For P = 1 To UBound(xNode)
        TV(0).Nodes(P).Checked = xNode(P).Checked
    Next P
    
    Erase xNode
    
    nStyle = vData
    
    PropertyChanged "Style"
    
End Property
Public Property Get NewIndex() As Integer
    NewIndex = nNewIndex
End Property
Public Property Get Name() As String
    Name = TV(0).Name
End Property
Public Property Get List(Index As Integer) As lItem
    Dim nIndex As Long
    Dim nodX As Node
    
    nIndex = LB.ItemData(Index)

    Set nodX = TV(0).Nodes(nIndex)
    
    List.BackColor = nodX.BackColor
    List.Bold = nodX.Bold
    List.Checked = nodX.Checked
    List.ForeColor = nodX.ForeColor
    List.ItemData = CLng(nodX.Tag)
    List.Text = nodX.Text
    
    Set nodX = Nothing

End Property
Public Property Get Hwnd() As OLE_HANDLE
    Hwnd = TV(0).Hwnd
End Property
Public Property Get ListIndex() As Integer
    
    On Local Error Resume Next
    
    ListIndex = TV(0).SelectedItem.Index - 1

    If Err.Number = 91 Then ListIndex = -1

End Property
Public Property Get ListCount() As Integer
    ListCount = TV(0).Nodes.Count
End Property
Public Property Get Apperance() As Apperance
    Apperance = TV(0).Appearance
End Property
Public Property Let Apperance(vData As Apperance)
    TV(0).Appearance = vData
    PropertyChanged "Apperance"
End Property
Public Property Get BorderStyle() As BorderStyle
    BorderStyle = TV(0).BorderStyle
End Property
Public Property Let BorderStyle(vData As BorderStyle)
    TV(0).BorderStyle = vData
    PropertyChanged "BorderStyle"
End Property
Public Property Get Enabled() As Boolean
    Enabled = TV(0).Enabled
End Property
Public Property Let Enabled(vData As Boolean)
    TV(0).Enabled = vData
    PropertyChanged "Enabled"
End Property
Public Property Get Font() As Font
    Set Font = TV(0).Font
End Property
Public Property Set Font(ByVal New_Font As IFontDisp)
    Set TV(0).Font = New_Font
    PropertyChanged "Font"
End Property
Public Property Get Sorted() As Boolean
    Sorted = isSorted
End Property
Public Property Let Sorted(vData As Boolean)
    Dim P As Integer, c As Integer, Index As Integer
    Dim nodX As Node
    
    isSorted = vData
    
    nS.Clear
    nU.Clear

    If isSorted Then
        Set LB = nS
    Else
        Set LB = nU
    End If
        
    c = TV(0).Nodes.Count - 1
    If c > -1 Then ReDim xNode(c)
    
    For P = 1 To TV(0).Nodes.Count
        Set nodX = TV(0).Nodes(P)
        
        LB.AddItem nodX.Text
        LB.ItemData(LB.NewIndex) = (P - 1)
        
        xNode(P - 1).BackColor = nodX.BackColor
        xNode(P - 1).Bold = nodX.Bold
        xNode(P - 1).Checked = nodX.Checked
        xNode(P - 1).ForeColor = nodX.ForeColor
        xNode(P - 1).ItemData = CLng(nodX.Tag)
    Next P
    
    TV(0).Nodes.Clear
    
    For P = 0 To LB.ListCount - 1
        Index = LB.ItemData(P)
        LB.ItemData(P) = P + 1

        TV(0).Nodes.Add , , , LB.List(P)
        
        Set nodX = TV(0).Nodes(TV(0).Nodes.Count)
        
        nodX.BackColor = xNode(Index).BackColor
        nodX.Bold = xNode(Index).Bold
        nodX.Checked = xNode(Index).Checked
        nodX.ForeColor = xNode(Index).ForeColor
        nodX.Selected = False
        nodX.Tag = xNode(Index).ItemData
    Next P
    
    TV(0).Refresh
    
    Erase xNode
    
    Set nodX = Nothing
        
End Property
Private Sub TV_BeforeLabelEdit(Index As Integer, Cancel As Integer)
    Cancel = 1
End Sub
Private Sub TV_Click(Index As Integer)
    RaiseEvent Click
End Sub
Private Sub TV_DblClick(Index As Integer)
    RaiseEvent DblClick
End Sub
Private Sub TV_KeyDown(Index As Integer, KeyCode As Integer, Shift As Integer)
    RaiseEvent KeyDown(KeyCode, Shift)
End Sub
Private Sub TV_KeyPress(Index As Integer, KeyAscii As Integer)
    RaiseEvent KeyPress(KeyAscii)
End Sub
Private Sub TV_KeyUp(Index As Integer, KeyCode As Integer, Shift As Integer)
    RaiseEvent KeyUp(KeyCode, Shift)
End Sub
Private Sub TV_MouseDown(Index As Integer, Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseDown(Button, Shift, X, Y)
End Sub
Private Sub TV_MouseMove(Index As Integer, Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseMove(Button, Shift, X, Y)
End Sub
Private Sub TV_MouseUp(Index As Integer, Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseUp(Button, Shift, X, Y)
End Sub
Private Sub TV_NodeCheck(Index As Integer, ByVal Node As MSComctlLib.Node)
    RaiseEvent ItemCheck(Node.Index - 1)
End Sub
Private Sub TV_NodeClick(Index As Integer, ByVal Node As MSComctlLib.Node)
    RaiseEvent ItemClick(Node.Index - 1)
End Sub
Private Sub UserControl_Initialize()
    Call Init
End Sub
Private Sub Init()
    
    Call GetGlobalVar(My)
    
    TV(0).Top = 0
    TV(0).Left = 0
    
    TV(0).Width = UserControl.Width
    TV(0).Height = UserControl.Height
    
    TV(0).FullRowSelect = True
    TV(0).Style = tvwTextOnly
    
    Call Clear
    
    Set LB = nS
    
End Sub
Public Sub Clear()
    
    TV(0).Nodes.Clear
    
    nS.Clear
    nU.Clear
    
    Call ClearVar
    
End Sub
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    TV(0).Appearance = PropBag.ReadProperty("Apperance", cc3D)
    TV(0).BorderStyle = PropBag.ReadProperty("BorderStyle", FixedSingle)
    TV(0).Enabled = PropBag.ReadProperty("Enabled", True)
    TV(0).Font = PropBag.ReadProperty("Font", Ambient.Font)
    TV(0).Sorted = PropBag.ReadProperty("Sorted", False)
    nStyle = PropBag.ReadProperty("Style", 0)
End Sub
Private Sub UserControl_Resize()
    TV(0).Width = UserControl.Width
    TV(0).Height = UserControl.Height
End Sub
Private Sub UserControl_Terminate()
    Call ClearVar
    Set LB = Nothing
End Sub
Private Sub ClearVar()
    nNewIndex = -1
    Erase xNode
End Sub
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    Call PropBag.WriteProperty("Apperance", TV(0).Appearance, cc3D)
    Call PropBag.WriteProperty("BorderStyle", TV(0).BorderStyle, FixedSingle)
    Call PropBag.WriteProperty("Enabled", TV(0).Enabled, True)
    Call PropBag.WriteProperty("Font", TV(0).Font, Ambient.Font)
    Call PropBag.WriteProperty("Sorted", isSorted, False)
    Call PropBag.WriteProperty("Style", nStyle, 0)
End Sub
Public Function AddItem(ByVal Text As String, _
                        Optional ItemData As Variant, _
                        Optional BackColor As Variant, _
                        Optional ForeColor As Variant, _
                        Optional Bold As Boolean, _
                        Optional Checked As Boolean, _
                        Optional Index As Variant) _
                                        As Integer
    Dim P As Integer, nIndex As Integer
    Dim Relation As Integer
    Dim nodX As Node
    
    If IsMissing(BackColor) Then BackColor = vbWindowBackground
    If IsMissing(ForeColor) Then ForeColor = vbWindowText
    If IsMissing(ItemData) Then ItemData = 0
    
    If Not IsMissing(Index) Then
        If isSorted Then
            Call DoError(0)
            Exit Function
        Else
            LB.AddItem Text, Index
        End If
    Else
        LB.AddItem Text
    End If
    
    nIndex = LB.NewIndex
    
    If Not isSorted Or TV(0).Nodes.Count = 0 Then
        If IsMissing(Index) Then
            TV(0).Nodes.Add , , , Text
        Else
            If Index > 0 Then
                Relation = tvwNext
                nIndex = LB.ItemData(nIndex - 1)
            Else
                Relation = tvwPrevious
                nIndex = LB.ItemData(1)
            End If
            
            TV(0).Nodes.Add nIndex, Relation, , Text
        End If
    Else
        If nIndex > 0 Then
            Relation = tvwNext
            nIndex = LB.ItemData(nIndex - 1)
        Else
            Relation = tvwPrevious
            nIndex = LB.ItemData(1)
        End If
    
        TV(0).Nodes.Add nIndex, Relation, , Text
    End If
    
    Set nodX = TV(0).Nodes(TV(0).Nodes.Count)
    
    nodX.BackColor = CLng(BackColor)
    nodX.Bold = CBool(Bold)
    nodX.Checked = CBool(Checked)
    nodX.ForeColor = CLng(ForeColor)
    If Not IsMissing(ItemData) Then nodX.Tag = CLng(ItemData)
    nodX.Selected = False
    
    If Relation = tvwPrevious Then nIndex = 0
    LB.ItemData(nIndex) = TV(0).Nodes.Count
    
    nNewIndex = nIndex
    AddItem = nIndex

End Function
Public Sub RemoveItem(ByVal Index As Integer)
    Dim P As Integer, nIndex As Integer, X As Integer
    
    Index = Index + 1
    
    nIndex = TV(0).Nodes(Index).Index
    
    TV(0).Nodes.Remove Index
    
    For P = 0 To LB.ListCount - 1
        If LB.ItemData(P) > nIndex Then
            LB.ItemData(P) = LB.ItemData(P) - 1
        Else
            If LB.ItemData(P) = nIndex Then X = P
        End If
    Next P
    
    LB.RemoveItem X
    
End Sub
Public Sub Move(Left As Single, _
                Optional Top As Variant, _
                Optional Width As Variant, _
                Optional Height As Variant)
    TV(0).Move Left, Top, Width, Height
End Sub
Public Sub Refresh()
    TV(0).Refresh
End Sub
Public Sub SetFocus()
    TV(0).SetFocus
End Sub
Public Sub ZOrder(Optional Position As Variant)
    If Not IsMissing(Position) Then
        TV(0).ZOrder Position
    Else
        TV(0).ZOrder
    End If
End Sub
Public Function FindItem(Text As String, _
                         Optional FindExact As Boolean) _
                                As Integer
    Dim P As Integer
    
    FindItem = SearchLB(LB.Hwnd, LB_FINDSTRINGEXACT, _
                        -1, Text)
    
    If FindExact Then
       If LB.List(FindExact) <> Text Then
            For P = FindExact + 1 To LB.ListCount - 1
                If LB.List(P) = Text Then _
                    FindItem = P: _
                    Exit Function
            Next P
        
            FindItem = -1
        End If
    End If
            
End Function
Public Sub About()
    About1.Show
End Sub
Private Sub DoError(ByVal Index As Integer)
    Dim But As Integer
    Dim M As String, t As String
    
    But = vbCritical + vbOKOnly
    t = "ColorListBox - Error"
    
    Select Case Index
        Case 0
            M = "Index kann nur angegeben werden, " & _
                "wenn sich die Listbox im unsortieten " & _
                "Zustand befindet (Sorted = False)." & _
                vbCrLf & vbCrLf & _
                "Gemachte Angaben werden ignoriert !"
        Case 1
            M = "Eigenschaft ist schreibgeschtzt."
    End Select
    
    MsgBox M, But, t
    
End Sub
Public Sub SetList(Index As Integer, _
                   Optional Text As Variant, _
                   Optional ItemData As Variant, _
                   Optional BackColor As Variant, _
                   Optional ForeColor As Variant, _
                   Optional Bold As Variant, _
                   Optional Checked As Variant)
    Dim P As Integer, nIndex As Integer
    Dim nNode As nNodeNFO
    Dim nodX As Node
    
    nIndex = LB.ItemData(Index)
    Set nodX = TV(0).Nodes(nIndex)
    
    nNode.BackColor = nodX.BackColor
    nNode.Bold = nodX.Bold
    nNode.Checked = nodX.Checked
    nNode.ForeColor = nodX.ForeColor
    nNode.ItemData = nodX.Tag
    nNode.Text = nodX.Text
        
    If Not IsMissing(Text) Then _
        nNode.Text = CStr(Text)
    If Not IsMissing(ItemData) Then _
        nNode.ItemData = CLng(ItemData)
    If Not IsMissing(BackColor) Then _
        nNode.BackColor = CLng(BackColor)
    If Not IsMissing(ForeColor) Then _
        nNode.ForeColor = CLng(ForeColor)
    If Not IsMissing(Bold) Then _
        nNode.Bold = CBool(Bold)
    If Not IsMissing(Checked) Then _
        nNode.Checked = CBool(Checked)
    
    If Not isSorted Then
        If Not IsMissing(Text) Then _
            nU.List(Index) = nNode.Text: _
            nodX.Text = nNode.Text
        
        nodX.Tag = nNode.ItemData
        nodX.BackColor = nNode.BackColor
        nodX.ForeColor = nNode.ForeColor
        nodX.Bold = nNode.Bold
        nodX.Checked = nNode.Checked
    Else
        Call RemoveItem(Index)
        
        nIndex = AddItem(nNode.Text, nNode.ItemData, _
                         nNode.BackColor, nNode.ForeColor, _
                         nNode.Bold, nNode.Checked)
    End If
    
End Sub
